;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-ascii)
(require 'bad-borderless)
(require 'bad-box)
(require 'bad-caption)
(require 'bad-elem)

(defclass game (elem)
  ((name   :initform "bad/draw game")
   (w      :initform #1=78)
   (h      :initform #2=31)
   (screen :initarg :screen :type box
           :initform (box :name "screen"
                          :w  #1#
                          :h  #2#
                          :c1 #1=?\s :s1 #2='(#1#) :c2 #1#
                          :s4 #2#                  :s2 #2#
                          :c4 #1#    :s3      #2#  :c3 #1#))
   (level :initarg :level :type integer              :initform 1)
   (bg    :initarg :bg    :type (or null ascii)      :intiform nil)
   (field :initarg :field :type (or null borderless) :initform nil)
   (help  :initarg :help  :type (or null caption)    :initform nil)
   (tmr   :initarg :tmr   :type (or null vector)     :initform nil)))

(cl-defmethod help-toggle ((g game))
  (with-slots (help) g
    (switch help))
  (draw g))

(provide 'bad-game)
