;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-box)
(require 'bad-cyclic)
(require 'bad-draw)
(require 'bad-elem)
(require 'bad-move)
(require 'bad-rotate)
(require 'bad-size)
(require 'bad-solid)
(require 'bad-triangle)

(require 'bad-mode-buffer)

(define-derived-mode bad-mode fundamental-mode "bad")

(defun bad-mode-hook-f ()
  (let ((inhibit-message t))
    (setq extended-command-suggest-shorter nil)
    (setq mode-line-format nil)
    (blink-cursor-mode -1)
    (font-lock-mode    -1)
    (menu-bar-mode     -1)
    (scroll-bar-mode   -1)
    (tool-bar-mode     -1)))

(setq bad-mode-hook #'bad-mode-hook-f)

(defvar bad-mode-map)

(provide 'bad-mode)
